/*  $Id: resource_generic.h,v 1.5 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_resource_generic
#define header_resource_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <map>
#include <string>
#include "API/Core/XML/dom_element.h"

class CL_ResourceData;
class CL_ResourceManager_Generic;

class CL_Resource_Generic
{
//! Construction:
public:
	CL_Resource_Generic(CL_DomElement &element, CL_ResourceManager_Generic *manager);

	~CL_Resource_Generic();

//! Attributes:
public:
	std::map<std::string, CL_ResourceData*> datas;

	int ref_count, load_ref;

	CL_ResourceManager_Generic *manager;

	CL_DomElement element;

//! Operations:
public:
	void add_ref();

	void release_ref();

//! Implementation:
private:
};

#endif
