/*  $Id: xml_token_generic.h,v 1.4 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_xml_token_generic
#define header_xml_token_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/XML/xml_token.h"
#include <map>
#include <string>

class CL_XMLToken_Generic
{
//! Construction:
public:
	CL_XMLToken_Generic() : ref_count(0), type(CL_XMLToken::NULL_TOKEN), variant(CL_XMLToken::SINGLE) { return; }
	
	~CL_XMLToken_Generic() { return; }
	
//! Attributes:
public:
	int ref_count;

	CL_XMLToken::TokenType type;

	CL_XMLToken::TokenVariant variant;
	
	std::string name;

	std::string value;
	
	std::vector< std::pair<std::string, std::string> > attributes;

//! Implementation:
private:
};

#endif
