/*  $Id: input_device_win32keyboard.h,v 1.7 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_input_device_win32keyboard
#define header_input_device_win32keyboard

#if _MSC_VER > 1000
#pragma once
#endif

#include "../input_device_generic.h"

class CL_DisplayWindow_Win32;

class CL_InputDevice_Win32Keyboard : public CL_InputDevice_Generic
{
//! Construction:
public:
	CL_InputDevice_Win32Keyboard(CL_DisplayWindow_Win32 *window);

	virtual ~CL_InputDevice_Win32Keyboard();

//! Attributes:
public:
	//: Returns true if the passed key code is down for this device.
	virtual bool get_keycode(int keycode) const;

	//: Key name for specified identifier (A, B, C, Space, Enter, Backspace).
	virtual std::string get_key_name(int id) const;

//! Operations:
public:

//! Implementation:
private:
	CL_DisplayWindow_Win32 *window;
};

#endif
