/*  $Id: menunode_generic.cpp,v 1.9 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"

#include "API/GUI/component.h"
#include "API/GUI/popupmenu.h"
#include "menunode_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_MenuNode_Generic::CL_MenuNode_Generic(CL_MenuNode *self, CL_PopupMenu *submenu)
{
	menunode = self;
	
	this->submenu = submenu;

	component = NULL;
	delete_component = false;

	userdata = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_MenuNode_Generic::on_child_click(const CL_InputEvent &key)
{
	if(submenu)
	{
		CL_Component *root = component->get_root_parent();

		// Position new popup
		CL_Rect pos = component->get_screen_rect();
		if(pos.right + submenu->get_width() > root->get_width()) // Will it be outside view?
			pos.right -= (component->get_width() + submenu->get_width());  // If so, move it to the left side
		submenu->set_position(pos.right, pos.top);

		// Pop it up
		submenu->popup(root);
	}
}
