/*  $Id: popupmenu.cpp,v 1.35 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"

#ifdef WIN32
#pragma warning (disable:4355)
#endif

#include "API/GUI/stylemanager.h"
#include "popupmenu_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_PopupMenu::CL_PopupMenu(
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(parent, style), CL_MenuData(this), impl(NULL)
{
	impl = new CL_PopupMenu_Generic(this);
	get_style_manager()->connect_styles("popupmenu", this);
}

CL_PopupMenu::CL_PopupMenu(
	const CL_Rect &pos,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(pos, parent, style), CL_MenuData(this), impl(NULL)
{
	impl = new CL_PopupMenu_Generic(this);
	get_style_manager()->connect_styles("popupmenu", this);
}

CL_PopupMenu::~CL_PopupMenu()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_PopupMenu::popup(CL_Component *parent)
{
	impl->popup(parent);
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

/////////////////////////////////////////////////////////////////////////////
// Signals:

CL_Signal_v1<const CL_MenuNode &> &CL_PopupMenu::sig_selection_changed()
{
	return impl->sig_selection_changed;
}

CL_Signal_v0 &CL_PopupMenu::sig_cancelled()
{
	return impl->sig_cancelled;
}
