/*  $Id: treeitem_generic.cpp,v 1.5 2003/09/18 17:53:29 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"
#include "treeitem_generic.h"
#include "API/GUI/treeitem.h"
#include "API/GUI/component.h"
#include "API/GUI/stylemanager.h"
#include "API/Core/XML/dom_element.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_TreeItem_Generic::CL_TreeItem_Generic(
	CL_TreeItem *self,
	CL_TreeNode *node,
	const std::string &text)
:  text(text), node(node), item(self)
{
	slot_mouse_down = item->sig_mouse_down().connect(
		this, &CL_TreeItem_Generic::on_mouse_down);
	slot_set_options = item->sig_set_options().connect(
		this, &CL_TreeItem_Generic::on_set_options);
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_TreeItem_Generic::on_mouse_down(const CL_InputEvent &key)
{
	item->sig_clicked()();
}

void CL_TreeItem_Generic::on_set_options(const CL_DomElement &options)
{
	if (options.has_attribute("text"))
		text = options.get_attribute("text");
}
