/*  $Id: treenode_generic.h,v 1.8 2003/10/14 15:52:13 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_treenode_generic
#define header_treenode_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <list>
#include "API/Signals/slot_container.h"
#include "API/Core/Math/point.h"
#include "API/Display/input_event.h"

class CL_TreeNode;

//: TreeView node
class CL_TreeNode_Generic
{
public:
	CL_TreeNode_Generic(CL_TreeNode *self, CL_TreeView *root);
	
	void set_collapsed(bool new_collapsed);
		
	CL_TreeView *root;
	CL_Component *component;
	bool delete_component;

	std::list<CL_TreeNode *> children;

	CL_SlotContainer slots;

	void *userdata;

	bool collapsed;
	bool selected;

	void on_child_click(const CL_InputEvent &key);

	CL_Signal_v1<CL_Point &> sig_paint_node;
	
private:
	CL_TreeNode *treenode;
};

#endif
