/*  $Id: progressbar_boring.cpp,v 1.4 2003/09/08 15:06:24 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "API/Display/surface.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUIStyleBoring/progressbar_boring.h"
#include "API/GUIStyleBoring/stylemanager_boring.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_ProgressBar_Boring::CL_ProgressBar_Boring(
	CL_ProgressBar *progressbar,
	CL_StyleManager_Boring *style)
:
	CL_ComponentStyle(progressbar),
	style(style),
	progressbar(progressbar)
{
	slot_paint = progressbar->sig_paint().connect(
		this, &CL_ProgressBar_Boring::on_paint);
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_ProgressBar_Boring::on_paint()
{
	int width = progressbar->get_width();
	int height = progressbar->get_height();
	float percent = progressbar->get_percentage();

	// Outline
	style->draw_rect(0, 0, width, height, GUICOLOR_DARK_OUTLINE);

	// Shade box
	style->draw_box(1, 1, width - 1 , height - 1, GUICOLOR_DARK_SHADE, GUICOLOR_BRIGHT_SHADE);

	// Fill
	int length = (int) ((width - 4) * percent);

	style->fill_rect(2, 2, 2 + length, height - 2, GUICOLOR_PROGRESSBAR_FILLED);
	style->fill_rect(2 + length, 2, width - 2, height - 2, GUICOLOR_PROGRESSBAR);
}
