/*  $Id: browse_master.cpp,v 1.6 2003/07/20 22:34:39 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include "API/Network/Browse/browse_master.h"
#include "browse_master_generic.h"
#include <stdlib.h>

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseMaster construction:

CL_BrowseMaster::CL_BrowseMaster()
: impl(NULL)
{
	impl = new CL_BrowseMaster_Generic();
}
	
CL_BrowseMaster::~CL_BrowseMaster()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseMaster attributes:

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseMaster operations:

void CL_BrowseMaster::start_listen(const CL_IPAddress &bind_address)
{
	impl->start_listen(bind_address);
}

void CL_BrowseMaster::stop_listen()
{
	impl->stop_listen();
}

void CL_BrowseMaster::run()
{
	impl->run();
}

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseMaster implementation:
