/*  $Id: soundbuffer_generic.cpp,v 1.4 2003/07/20 22:21:27 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Sound/precomp.h"
#include "soundbuffer_generic.h"
#include "API/Sound/soundprovider.h"
#include "API/Sound/soundfilter.h"

/////////////////////////////////////////////////////////////////////////////
// CL_SoundBuffer_Generic construction:

CL_SoundBuffer_Generic::CL_SoundBuffer_Generic() :
	provider(0), delete_provider(false),
	volume(0.0f), pan(0.0f), ref_count(0)
{
}
	
CL_SoundBuffer_Generic::~CL_SoundBuffer_Generic()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_SoundBuffer_Generic attributes:

	
/////////////////////////////////////////////////////////////////////////////
// CL_SoundBuffer_Generic operations:

void CL_SoundBuffer_Generic::add_ref()
{
	CL_MutexSection mutex_lock(&mutex);
	ref_count++;
}

void CL_SoundBuffer_Generic::release_ref()
{
	CL_MutexSection mutex_lock(&mutex);
	if (--ref_count == 0)
	{
		mutex_lock.leave();
		delete this;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CL_SoundBuffer_Generic implementation:
