/*  $Id: voice_decoder.cpp,v 1.4 2003/09/19 22:55:42 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Voice/voice_decoder.h"
#include "voice_decoder_generic.h"
#include "voice_decoder_hawkvoice.h"

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceDecoder construction:

CL_VoiceDecoder::CL_VoiceDecoder()
: impl(new CL_VoiceDecoder_Hawkvoice)
{
}

CL_VoiceDecoder::~CL_VoiceDecoder()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceDecoder attributes:

int CL_VoiceDecoder::get_num_samples() const
{
	return impl->num_samples;
}

int CL_VoiceDecoder::get_frequency() const
{
	return impl->freq;
}

int CL_VoiceDecoder::get_position() const
{
	return impl->position;
}

CL_SoundFormat CL_VoiceDecoder::get_format() const
{
	return impl->format;
}

int CL_VoiceDecoder::get_num_channels() const
{
	return impl->num_channels;
}

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceDecoder operations:

void CL_VoiceDecoder::decode_packet(const std::string &packet)
{
}

bool CL_VoiceDecoder::eof() const
{
	return false;
}
	
void CL_VoiceDecoder::stop()
{
}

bool CL_VoiceDecoder::play()
{
	return true;
}
		
bool CL_VoiceDecoder::set_position(int pos)
{
	return false;
}
	
int CL_VoiceDecoder::get_data(void **data_ptr, int data_requested)
{
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceDecoder implementation:
