/*  $Id: voice_encoder.cpp,v 1.3 2003/09/19 22:55:42 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Voice/voice_encoder.h"
#include "voice_encoder_generic.h"
#include "voice_encoder_hawkvoice.h"

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceEncoder construction:

CL_VoiceEncoder::CL_VoiceEncoder(
	CL_SoundProvider_Session *source,
	CL_VoiceCodec codec)
: impl(new CL_VoiceEncoder_Hawkvoice(source, codec))
{
}

CL_VoiceEncoder::~CL_VoiceEncoder()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceEncoder operations:

std::string CL_VoiceEncoder::encode_packet()
{
	return impl->encode_packet();
}

/////////////////////////////////////////////////////////////////////////////
// CL_VoiceEncoder implementation:
