
#include "dlg_new_component.h"

/////////////////////////////////////////////////////////////////////////////
// DlgNewComponent construction:

DlgNewComponent::DlgNewComponent(CL_Component *parent)
: CL_Window(0, parent->get_style_manager())
{
	list_components = new CL_ListBox(get_client_area());
	button_ok = new CL_Button(get_client_area());
	button_cancel = new CL_Button(get_client_area());

	set_title("Create New Component");
	set_position(CL_Rect(parent->get_width()/2-100, parent->get_height()/2-150, parent->get_width()/2+100, parent->get_height()/2+150));

	int client_width = get_client_area()->get_width();
	int client_height = get_client_area()->get_height();

	list_components->set_position(CL_Rect(0, 0, client_width, client_height-30));
	button_ok->set_position(CL_Rect(client_width-150, client_height-26, client_width-77, client_height-4));
	button_cancel->set_position(CL_Rect(client_width-73, client_height-26, client_width, client_height-4));

	button_ok->set_text("Ok");
	button_cancel->set_text("Cancel");

	slots.connect(button_ok->sig_clicked(), this, &DlgNewComponent::button_ok_clicked);
	slots.connect(button_cancel->sig_clicked(), this, &DlgNewComponent::button_cancel_clicked);

	// Fill component list:
	std::map<std::string,CL_ComponentType *>::iterator it;

	for (it = CL_ComponentType::component_types.begin(); it != CL_ComponentType::component_types.end(); it ++)
	{
		list_components->insert_item((*it).first);
	}

	list_components->set_current_item(0);
}

DlgNewComponent::~DlgNewComponent()
{
	delete list_components;
	delete button_ok;
	delete button_cancel;
}

/////////////////////////////////////////////////////////////////////////////
// DlgNewComponent attributes:


/////////////////////////////////////////////////////////////////////////////
// DlgNewComponent operations:

bool DlgNewComponent::run()
{
	retval = false;
	CL_Window::run();
	return retval;
}

/////////////////////////////////////////////////////////////////////////////
// DlgNewComponent implementation:

void DlgNewComponent::button_ok_clicked()
{
	retval = true;
	quit();
}

void DlgNewComponent::button_cancel_clicked()
{
	retval = false;
	quit();
}
